/*=============================================================================
    Copyright (c) 1998-2003 Joel de Guzman
    Copyright (c) 2001-2003 Daniel Nuffer
    Copyright (c) 2001-2003 Hartmut Kaiser
    Copyright (c) 2002-2003 Martin Wille
    Copyright (c) 2002 Juan Carlos Arevalo-Baeza
    Copyright (c) 2002 Raghavendra Satish
    Copyright (c) 2002 Jeff Westfahl
    http://spirit.sourceforge.net/

    Use, modification and distribution is subject to the Boost Software
    License, Version 1.0. (See accompanying file LICENSE_1_0.txt or copy at
    http://www.boost.org/LICENSE_1_0.txt)
=============================================================================*/
#if !defined(BOOST_SPIRIT_UTILITY_MAIN_HPP)
#define BOOST_SPIRIT_UTILITY_MAIN_HPP

#include <boost/spirit/version.hpp>

///////////////////////////////////////////////////////////////////////////////
//
//  Master header for Spirit.Utilities
//
///////////////////////////////////////////////////////////////////////////////

// Utility.Parsers
#include <boost/spirit/utility/parsers/chset.hpp>
#include <boost/spirit/utility/parsers/chset_operators.hpp>
#include <boost/spirit/utility/parsers/escape_char.hpp>
#include <boost/spirit/utility/parsers/functor_parser.hpp>
#include <boost/spirit/utility/parsers/loops.hpp>
#include <boost/spirit/utility/parsers/confix.hpp>
#include <boost/spirit/utility/parsers/lists.hpp>
#include <boost/spirit/utility/parsers/distinct.hpp>

// Utility.Support
#include <boost/spirit/utility/support/flush_multi_pass.hpp>
#include <boost/spirit/utility/support/scoped_lock.hpp>


#endif // !defined(BOOST_SPIRIT_UTILITY_MAIN_HPP)
